#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);cout.tie(NULL);
    long long n;
    cin>>n;
    long long a[n];
    for(long long i=0;i<n;i++)cin>>a[i];
    long long q;
    cin>>q;
    for(long long i=0;i<q;i++)
    {
        long long l,r,h=-1;
        cin>>l>>r;
        bool p1=true,p2=true;
        for(long long i1=l-1;i1<r-1&&p2;i1++)
        {
            if(h==i1+1)
            {
                if(i1+2!=r-1)
                if(a[i1]>a[i1+2])
                {
                    p2=false;
                }
            }
            else if(h==i1)
            {
                if(i1!=l)
                if(a[i1-1]>a[i1+1])
                {
                    p2=false;
                }
            }
            else if(a[i1]>a[i1+1])
            {
                if(p1)
                {
                    p1=false;
                    if(i1=l-1)continue;
                    else if(a[i1-1]>a[i1+1])h=i1+1;
                    else h=i1;
                }
                else p2=false;
            }
        }
        if(p2)cout<<"DA\n";
        else cout<<"NE\n";
    }
}